<!-- 部门筛选选择器 -->
<template>
  <div>
    <div>
      <el-input v-model="deptName" placeholder="请输入部门名称" clearable size="small" prefix-icon="el-icon-search"
        style="margin-bottom: 20px" />
    </div>
    <div>
      <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false" :filter-node-method="filterNode"
        ref="tree" node-key="id" default-expand-all highlight-current @node-click="handleNodeClick" />
    </div>
  </div>
</template>

<script>
import { deptTreeSelect } from "@/api/system/user";

export default {
  name: "deptSearchComponent",
  data() {
    return {
      defaultProps: {
        children: "children",
        label: "label"
      },
      // 部门树选项
      deptOptions: undefined,
      // 部门名称
      deptName: undefined,
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  mounted() {
    this.getDeptTree();
  },
  // 解绑事件
  beforeDestroy() {
    this.$bus.$off('on-getDeptTree');
  },
  methods: {
    /** 查询部门下拉树结构 */
    getDeptTree() {
      deptTreeSelect().then(response => {
        this.deptOptions = response.data;
        this.$bus.$emit('on-getDeptTreeData', response.data)
        this.$emit('on-getDeptTree', response.data)
      });
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.label.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.$emit('on-selectDept', data.id)
    }
  },
};
</script>

<style scoped></style>
